/*
 * GREAT-ER
 *
 * MODEL.H
 *
 * author =  Geert Boeije
 * state =   01.09.1998
*/

#ifndef MODEL_H
#define MODEL_H

/* globals which are declared in MODEL.C */

extern FloatType RiverInternal[NR_STATEVARS];
extern FloatPtr  SegmentRivClass;
extern FloatType DryWeatherFlow;
extern FloatType WaterUse;
extern FloatType WWTP_DryWeatherFlow;
extern FloatType WWTP_SS_MassFlux;
extern Map_Ptr   ThisSegmentMap;
extern FloatType ThisSegmentID;
extern ChemProp  CP;
extern FloatType FugacityAir;
extern FloatType FugacityWater;
extern FloatType FugacityML;
extern FloatType FugacityPrimSludge;
extern FloatType DOSaturationML;
extern EmissionParPtr Em;

/* functions which are declared in MODEL.C */

void ChemicalProperties ( void );

void FindEmission ( void );

void Model_DomesticEmission ( FloatPtr process_par_arg,
                              FloatPtr general_par_arg );

void Model_NonDomesticEmission ( FloatPtr process_par_arg,
                                 FloatPtr general_par_arg );

void Model_RunoffEmission ( FloatPtr process_par_arg,
                            FloatPtr general_par_arg );

void Model_GenericTransportTreatment ( int      process_arg,
                                       FloatPtr process_par_arg,
                                       FloatPtr general_par_arg,                                       
                                       FloatPtr out_arg );

void Model_OnSiteTreatment ( FloatPtr process_par_arg,
                             FloatPtr general_par_arg );

void Model_Sewer ( FloatPtr process_par_arg,
                   FloatPtr general_par_arg );

void Model_Treatment ( FloatPtr process_par_arg,
                       FloatPtr general_par_arg );

void Model_GroundWater ( FloatPtr process_par_arg,
                         FloatPtr general_par_arg );

void Model_SurfaceWater ( FloatPtr process_par_arg,
                          FloatPtr general_par_arg );

void Model_River ( FloatPtr process_par_arg,
                   FloatPtr general_par_arg );

void SegmentControlSection ( int       current_segment_arg,
                             FloatPtr  segment_par_arg,
                             FloatPtr  segment_rivclass_arg,
                             FloatPtr  segment_iface_arg,
                             FloatPtr  segment_summary_arg );

#endif

