/*
 * GREAT-ER
 *
 * NAMES.H
 *
 * definition of state variable names, model names, unit names etc.
 *
 * author =  Geert Boeije
 * state =   23.10.1998
*/

#ifndef NAMES_H
#define NAMES_H

static const char DistriParamName[][2][20] =
{
  /* none */
  {
    "mean",
    ""
  },
  /* normal */
  {
    "mean",
    "stdev"
  },
  /* lognormal */
  {
    "mean",
    "stdev"
  },
  /* uniform */
  {
    "min",
    "max"
  },
  /* PEC type */
  {
    "mean",
    "95%%ile"
  },
  /* flow type */
  {
    "mean",
    "5%%ile"
  }
};



static const char TerminalName[][20] =
{
  "Input",
  "Output"
};

static const char SummaryTerminalName[][20] =
{
  "River Maximum",
  "River Output",
  "River Internal",
  "sewage influent",
  "sewage effluent",
  "(not used)"
};

static const char StateVarName[][20] =
{
  "Flow",
  "Chem. Flux"
};

static const char StateVarUnit[][10] =
{
  "m3/s",
  " g/s"
};

static const char SummaryVarName[][20] = 
{
  "PEC"
};

static const char SummaryVarUnit[][10] =
{
  "mg/l"
};

static const char ProcessName[][30] =
{
  "Domestic Emission",
  "Non-domestic Emission",
  "Runoff",
  "Domestic On-site Treatment",
  "Sewer Transport",
  "Waste Water Treatment",
  "Surface Water Transport",
  "Ground Water Transport",
  "River Transport"
};

static const char SubmodelName[][MAX_NR_SUBMODELS][30] =
{
  {                     /* DOM */
    ""
/*
    "blackwater",
    "greywater"
*/
  },
  {                     /* NONDOM */
    ""
/*
    "industrial",
    "agricultural"
*/
  },
  {                     /* RUNOFF */
    ""
  },
  {                     /* ONSITE */
    "no treatment",
    "septic tank",
/*
    "local WWTP",
    "reed bed"
*/
  },
  {                     /* SEWER */
    ""
/*
    "separate sewer",
    "combined sewer"
*/
  },
  {                     /* WWTP */
    "untreated",
    "treated"
  },
  {                     /* GROUND WATER */
    ""
  },
  {                     /* SURFACE WATER */
    ""
  },
  {                     /* RIVER */
    ""
  }
};

#endif

