/*
 * GREAT-ER
 *
 * UTIL.C
 * 
 * several utilities
 *
 * author =  Geert Boeije
 * state =   01.09.1998
*/

#include <malloc.h>
#include <string.h>
#include "init.h"
#include "error.h"
#include "util.h"

/*
 * -------------------------------------------------------
 * Allocation of Memory
 * -------------------------------------------------------
*/

int AllocateGlobals ( int   step_arg, 
                      long* tot_alloc_arg )
{
  int test = 1;

  switch ( step_arg )
  {
    case 1:

      AsubMatrixOffset
        = (int *) MEMORY_ALLOC ( OneStateVarSize, IntSize );

      NonGeoRefDistriParIndex
        = (int *) MEMORY_ALLOC ( NR_NON_GEOREF_PARAMS, IntSize );

      NonGeoRefDistriType
        = (int *) MEMORY_ALLOC ( NR_NON_GEOREF_PARAMS, IntSize );

      ChemicalDistriParIndex
        = (int *) MEMORY_ALLOC ( NR_CHEMICAL_PARAMS, IntSize );

      ChemicalDistriType
        = (int *) MEMORY_ALLOC ( NR_CHEMICAL_PARAMS, IntSize );

      RivClassDistriParIndex
        = (int *) MEMORY_ALLOC ( NR_RIVCLASS_PARAMS, IntSize );

      RivClassDistriType
        = (int *) MEMORY_ALLOC ( NR_RIVCLASS_PARAMS, IntSize );

      RiverDistriParIndex
        = (int *) MEMORY_ALLOC ( NrParamsOnlyRiver, IntSize );

      RiverDistriType
        = (int *) MEMORY_ALLOC ( NrParamsOnlyRiver, IntSize );

      DischargeDistriParIndex
        = (int *) MEMORY_ALLOC ( NrParamsDischarge - NrParamsOnlyRiver, IntSize );

      DischargeDistriType
        = (int *) MEMORY_ALLOC ( NrParamsDischarge - NrParamsOnlyRiver, IntSize );

      WWTPDistriParIndex
        = (int *) MEMORY_ALLOC ( NR_WWTP_PARAMS, IntSize );

      WWTPDistriType
        = (int *) MEMORY_ALLOC ( NR_WWTP_PARAMS, IntSize );

      EmissionDistriParIndex
        = (int *) MEMORY_ALLOC ( NR_EMISSION_PARAMS, IntSize );

      EmissionDistriType
        = (int *) MEMORY_ALLOC ( NR_EMISSION_PARAMS, IntSize );

      SummaryDistriParIndex
        = (int *) MEMORY_ALLOC ( NR_SUMMARY_VARS * NR_SUMMARY_TERMS, IntSize );

      SummaryDistriType
        = (int *) MEMORY_ALLOC ( NR_SUMMARY_VARS * NR_SUMMARY_TERMS, IntSize );

      SegmentParOffset
        = (int *) MEMORY_ALLOC ( NrSegments, IntSize );

      Map
        = (Map_Ptr) MEMORY_ALLOC ( NrSegments, IntSize * MAP_SIZE );

      SegmentDone
        = (int *) MEMORY_ALLOC ( NrSegments, IntSize );

      *tot_alloc_arg += 
          (OneStateVarSize +
           NR_NON_GEOREF_PARAMS +
           NR_NON_GEOREF_PARAMS +
           NR_CHEMICAL_PARAMS +
           NR_CHEMICAL_PARAMS +
           NR_RIVCLASS_PARAMS +
           NR_RIVCLASS_PARAMS +
           NrParamsOnlyRiver +
           NrParamsOnlyRiver +
           NrParamsDischarge - NrParamsOnlyRiver +
           NrParamsDischarge - NrParamsOnlyRiver +
           NR_WWTP_PARAMS +
           NR_WWTP_PARAMS +
           NR_EMISSION_PARAMS +
           NR_EMISSION_PARAMS +
           NR_SUMMARY_VARS * NR_SUMMARY_TERMS +
           NR_SUMMARY_VARS * NR_SUMMARY_TERMS +
           NrSegments +
           sizeof (Map_Ptr) * NrSegments +
           NrSegments
          ) * IntSize ;


      test = ( AsubMatrixOffset &&
               NonGeoRefDistriParIndex &&
               NonGeoRefDistriType &&
               ChemicalDistriParIndex &&
               ChemicalDistriType &&
               RivClassDistriParIndex &&
               RivClassDistriType &&
               RiverDistriParIndex &&
               RiverDistriType &&
               DischargeDistriParIndex &&
               DischargeDistriType &&
               WWTPDistriParIndex &&
               WWTPDistriType &&
               EmissionDistriParIndex &&
               EmissionDistriType &&
               SummaryDistriParIndex &&
               SummaryDistriType &&
               SegmentParOffset &&
               Map &&
               SegmentDone );
      break;

    case 2:

      Distri_NonGeoRefParams
        = (FloatPtr) MEMORY_ALLOC ( TotNonGeoRefDistriPar, FloatSize );

      NonGeoRefParams
        = (NonGeoRef_ParPtr) MEMORY_ALLOC ( NR_NON_GEOREF_PARAMS, FloatSize );

      Distri_ChemicalParams
        = (FloatPtr) MEMORY_ALLOC ( TotChemicalDistriPar, FloatSize );

      ChemicalParams
        = (Chemical_ParPtr) MEMORY_ALLOC ( NR_CHEMICAL_PARAMS, FloatSize );

      Distri_RivClassParams
        = (FloatPtr) MEMORY_ALLOC ( TotRivClassDistriPar * NrRivClasses, FloatSize );

      CSewer_Q_DWF
        = (FloatPtr) MEMORY_ALLOC ( NrRivClasses, FloatSize );

      Distri_RiverParams
        = (FloatPtr) MEMORY_ALLOC ( TotRiverDistriPar * NrSegments, FloatSize );

      Distri_DischargeParams
        = (FloatPtr) MEMORY_ALLOC ( TotDischargeDistriPar * NrSegmentsDischarge, 
                                    FloatSize );

      Distri_WWTPParams
        = (FloatPtr) MEMORY_ALLOC ( TotWWTPDistriPar * NrWWTPs, FloatSize );

      WWTPData
        = (FloatPtr) MEMORY_ALLOC ( NR_WWTP_PARAMS * NrWWTPs, FloatSize );

      Distri_EmissionParams
        = (FloatPtr) MEMORY_ALLOC ( TotEmissionDistriPar * NrEmissions, FloatSize );

      EmissionData
        = (FloatPtr) MEMORY_ALLOC ( NR_EMISSION_PARAMS * NrEmissions, FloatSize );
        
      Distri_SummaryVars
        = (FloatPtr) MEMORY_ALLOC ( TotSummaryDistriPar * NrSegments, FloatSize );

      A = (FloatPtr) MEMORY_ALLOC ( AmatrixSize, FloatSize );

      B = (FloatPtr) MEMORY_ALLOC ( AllStateVarSize, FloatSize );

      X = (FloatPtr) MEMORY_ALLOC ( AllStateVarSize, FloatSize );

      WWTPExceptions
        = (FloatPtr) MEMORY_ALLOC ( NrWWTPExceptions * 2, FloatSize );

      RiverExceptions
        = (FloatPtr) MEMORY_ALLOC ( NrRiverExceptions * 2, FloatSize );

      *tot_alloc_arg += 
        ( TotNonGeoRefDistriPar +
          TotChemicalDistriPar +
          NR_NON_GEOREF_PARAMS +
          NR_CHEMICAL_PARAMS +
          TotRivClassDistriPar * NrRivClasses +
          NrRivClasses +
          TotRiverDistriPar * NrSegments +
          TotDischargeDistriPar * NrSegmentsDischarge +
          TotWWTPDistriPar * NrWWTPs +
          NR_EMISSION_PARAMS * NrEmissions +
          NR_WWTP_PARAMS * NrWWTPs +
          TotEmissionDistriPar * NrEmissions +
          TotSummaryDistriPar * NrSegments +
          AmatrixSize +
          AllStateVarSize +
          AllStateVarSize +
          NrWWTPExceptions +
          NrRiverExceptions
        ) * FloatSize;
                     
      test = ( Distri_NonGeoRefParams &&
               NonGeoRefParams &&
               Distri_ChemicalParams &&
               ChemicalParams &&
               Distri_RivClassParams &&
               CSewer_Q_DWF &&
               Distri_RiverParams &&
               Distri_DischargeParams &&
               Distri_WWTPParams &&
               EmissionData &&
               WWTPData &&
               Distri_EmissionParams &&
               Distri_SummaryVars &&
               A &&
               B &&
               X  &&
               WWTPExceptions &&
               RiverExceptions );
      break;

    default: break;
  }

  if (!test)
  {
    GenerateErrorMessage (901,NULL);
    return 0;
  }
  else
    return 1;
}

int AllocateLocals ( FloatPtr* allsegments_iface_arg, 
                     FloatPtr* allsegments_summary_arg,
                     FloatPtr* allsegments_sums_arg,
                     FloatPtr* allsegments_par_arg,
                     FloatPtr* allsegments_rivclass_arg,
                     long*     tot_alloc_arg               )
{
  int test;

  *allsegments_iface_arg
    = (FloatPtr) MEMORY_ALLOC ( AllIfaceSize, FloatSize );
    
  *allsegments_summary_arg
    = (FloatPtr) MEMORY_ALLOC ( AllSummarySize, FloatSize );
  
  *allsegments_sums_arg
    = (FloatPtr) MEMORY_ALLOC ( AllSummarySize * NR_SUMMARY_SUMS, FloatSize );
  
  *allsegments_par_arg
    = (FloatPtr) MEMORY_ALLOC ( AllParamSize, FloatSize ); 

  *allsegments_rivclass_arg
    = (FloatPtr) MEMORY_ALLOC ( NR_RIVCLASS_PARAMS * NrRivClasses, FloatSize ); 

  *tot_alloc_arg += 
    ( AllIfaceSize +
      AllSummarySize +
      AllSummarySize * NR_SUMMARY_SUMS +
      AllParamSize +
      NR_RIVCLASS_PARAMS * NrRivClasses
    ) * FloatSize;

  test = ( *allsegments_iface_arg &&
           *allsegments_summary_arg &&
           *allsegments_sums_arg &&
           *allsegments_par_arg &&
           *allsegments_rivclass_arg );

  if (!test)
  {
    GenerateErrorMessage (901,NULL);
    return 0;
  }
  else
    return 1;
}

/*
 * -------------------------------------------------------
 * Freeing Memory
 * -------------------------------------------------------
*/

void FreeGlobals ( void )
{
  FREE_MEMORY  ( (void *)  RiverExceptions);
  FREE_MEMORY  ( (void *)  WWTPExceptions);
  FREE_MEMORY  ( (void *)  X);
  FREE_MEMORY  ( (void *)  B);
  FREE_MEMORY  ( (void *)  A);
  FREE_MEMORY  ( (void *)  Distri_SummaryVars);
  FREE_MEMORY  ( (void *)  EmissionData);
  FREE_MEMORY  ( (void *)  Distri_EmissionParams);
  FREE_MEMORY  ( (void *)  WWTPData);
  FREE_MEMORY  ( (void *)  Distri_WWTPParams);
  FREE_MEMORY  ( (void *)  Distri_DischargeParams);
  FREE_MEMORY  ( (void *)  Distri_RiverParams);
  FREE_MEMORY  ( (void *)  Distri_RivClassParams);
  FREE_MEMORY  ( (void *)  CSewer_Q_DWF);
  FREE_MEMORY  ( (void *)  ChemicalParams);
  FREE_MEMORY  ( (void *)  Distri_ChemicalParams);
  FREE_MEMORY  ( (void *)  NonGeoRefParams);
  FREE_MEMORY  ( (void *)  Distri_NonGeoRefParams);
  FREE_MEMORY  ( (void *)  SegmentDone);
  FREE_MEMORY  ( (void *)  Map);
  FREE_MEMORY  ( (void *)  SegmentParOffset);
  FREE_MEMORY  ( (void *)  SummaryDistriType);
  FREE_MEMORY  ( (void *)  SummaryDistriParIndex);
  FREE_MEMORY  ( (void *)  EmissionDistriType);
  FREE_MEMORY  ( (void *)  EmissionDistriParIndex);
  FREE_MEMORY  ( (void *)  WWTPDistriType);
  FREE_MEMORY  ( (void *)  WWTPDistriParIndex);
  FREE_MEMORY  ( (void *)  DischargeDistriType);
  FREE_MEMORY  ( (void *)  DischargeDistriParIndex);
  FREE_MEMORY  ( (void *)  RiverDistriType);
  FREE_MEMORY  ( (void *)  RiverDistriParIndex);
  FREE_MEMORY  ( (void *)  RivClassDistriType);
  FREE_MEMORY  ( (void *)  RivClassDistriParIndex);
  FREE_MEMORY  ( (void *)  ChemicalDistriType);
  FREE_MEMORY  ( (void *)  ChemicalDistriParIndex);
  FREE_MEMORY  ( (void *)  NonGeoRefDistriType);
  FREE_MEMORY  ( (void *)  NonGeoRefDistriParIndex);
  FREE_MEMORY  ( (void *)  AsubMatrixOffset);
}

void FreeLocals ( FloatPtr  allsegments_iface_arg, 
                  FloatPtr  allsegments_summary_arg,
                  FloatPtr  allsegments_sums_arg,
                  FloatPtr  allsegments_par_arg,
                  FloatPtr  allsegments_rivclass_arg )
{
  FREE_MEMORY  ( (void *)  allsegments_rivclass_arg);
  FREE_MEMORY  ( (void *)  allsegments_par_arg);
  FREE_MEMORY  ( (void *)  allsegments_sums_arg);
  FREE_MEMORY  ( (void *)  allsegments_summary_arg);
  FREE_MEMORY  ( (void *)  allsegments_iface_arg);
}


/*
 * ----------------------------
 * set array(s) to zero
 * ----------------------------
*/

void CleanUpArrays (void)
{
  CleanUpArray ( A, AmatrixSize );
  CleanUpArray ( X, AllStateVarSize );
  CleanUpArray ( B, AllStateVarSize );
}

void CleanUpArray ( FloatPtr array_arg,
                    long     size_arg   )
{
  memset ( array_arg, 0, size_arg * FloatSize );
}

